;************************************************************************
;     :		main.asm
;    :		12.01.2011
;     :
;    :	16F876A, OSC = 19,66 
;    :		   russkihvp@rambler.ru
;
;    USART 32    
;     
;   9600,N,8,1

    list        p=16f876a 
	ERRORLEVEL -302	;     
;------------------------------------------------------------------------    
#include <p16f876a.inc>
;------------------------------------------------------------------------ 
   
    __CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_ON & _HS_OSC & _WRT_OFF & _LVP_OFF & _CPD_OFF

;------------------------------------------------------------------------
    		cblock 0x71	; 0x70  
			POINTER
     		endc

;************************************************************************
;
;	  ( )
;
;************************************************************************
		org 0
		nop				;  
		goto @@START	;     

;************************************************************************
; 	    
;************************************************************************
		org 	0x0004		;    
		retfie				;   

;************************************************************************
;	 
;************************************************************************
@@START

		banksel	TRISC
		movlw	b'11111111'	;  PORTC
		movwf	TRISC		; 	

		clrf	POINTER		;  
				
;------------------------------------------------------------------------
;	 USART  9600,N,8,1
;------------------------------------------------------------------------
		banksel RCSTA
		movlw	0x90
		movwf	RCSTA		
		banksel TXSTA
		movlw	0x24
		movwf	TXSTA		
		movlw	.127
		movwf	SPBRG			
;------------------------------------------------------------------------
;	  
;------------------------------------------------------------------------			
  		movlw (.255-.31)
		movwf	POINTER

@@MAIN_LOOP	
		banksel	PIR1
@@LOOP
		btfss	PIR1,TXIF
		goto	@@LOOP
		call	Value
		banksel	TXREG
		movwf	TXREG
		incfsz	POINTER,F
		goto	@@MAIN_LOOP
@@LOOP1	
		goto	@@LOOP1
Value
		movlw 	HIGH @@Table
		movwf 	PCLATH		
		movf 	POINTER,W		
		andlw 	0x1f		
		addlw 	LOW @@Table		
		btfsc 	STATUS,C		
		incf 	PCLATH,F		
		movwf 	PCL
;------------------------------------------------------------------------
;    
;------------------------------------------------------------------------
@@Table
		dt .36,.59,.90,.124,.144,.143,.122,.93,.67,.48,.38,.33,.34,.40,.54,.79
		dt .119,.171,.221,.247,.232,.185,.128,.82,.51,.33,.23,.19,.19,.21,.26,.36

;		dt .40,.31,.20,.11,.3,.0,.2,.11,.28,.53,.84,.117,.151,.181,.203,.215
;		dt .215,.203,.181,.151,.117,.84,.53,.28,.11,.2,.0,.3,.11,.20,.31,.40	
	end